'----------------------------------------------------------------------------------------------
'-      DISPLAYTEST & TOUCHSCREEN TEST with eDIP240-7 connected to ATMega8                    -
'-                                                                                            -
'-                                                                                            -
'-      Requirements:                                                                         -
'-                     - "displaymkrs_gallerydrive.eep" has to be uploaded on edip240-7       -
'-                     - i2c connection between atmega8 (sda=portd.2 / scl=portd.3) & edip    -
'-                     - edip pin6 on atmega8 pin b0 / edip pin7 on atmega8 pin b1            -
'-                     - eDIP240-7 with at least Firmware Version 1.6                         -
'-                     - close solderbridge J2 on eDIP to switch off smallprotocol            -
'-                     - rs232 terminal connected to atmega8                                  -
'----------------------------------------------------------------------------------------------

      $regfile = "m8def.dat"                                'Atmega8-declarations
      $crystal = 3686400
      $baud = 9600

      Ddrb = &B00000000                                     'switch portb.0 and portb.1 as inputs
      Portb = &B11111111                                    'switch on pullups for portb.0 and portb.1

'----- begin variables used in dspl and readvol subroutines -----

      Dim Send$ As String * 64 At &H60                      'string, which will be sent to eDIP 240-7 | fill this string with up to 62 characters before calling the "dspl"-subroutine
      Dim Send(64) As Byte At &H60 Overlay                  'pointer of send$
      Dim Sendlength As Byte                                'is used in dspl subroutine
      Dim Receivevol(5) As Byte                             'is used in "readvol"-subroutine
      Dim Volume As Byte                                    'will be reutrned from "readvol"-subroutine | values go from 0 to 100

'----- end variables used in dspl and readvol subroutines   -----

      Dim I As Integer                                      'general purpose counter - not used in subroutine

      Config Sda = Portd.2
      Config Scl = Portd.3
      Config I2cdelay = 10


'---------------------------------------------------------------------------------
'------------------------------ START PROGLOOP -----------------------------------
'---------------------------------------------------------------------------------

Do
   Waitms 3000

      Send$ = "{027}MN{001}"                                'starts macro#1 @ edip 240-7 (this macro will set the screen bgnd and define the bargraph for controlling the volume)
      Gosub Dspl

      Send$ = "{027}MN{004}"                                'starts macro#4 @edip 240-7 (this macro will set up the 'start' button)
      Gosub Dspl

      Volumeloop:
         Gosub Readvol                                      'reads out volume from bargraph @ edip 240-7 (macro#1 has to be started before to set up volume bargraph))
         Print Volume ; "  " ; Pinb.0 ; "  " ; Pinb.1
         Waitms 20
      Goto Volumeloop
Loop

'---------------------------------------------------------------------------------
'------------------------------- END PROGLOOP ------------------------------------
'---------------------------------------------------------------------------------

End

'---------------------------------------------------------------------------------
'----------------  Subroutine for sending data to edip 240-7 ---------------------
'---------------------------------------------------------------------------------
Dspl:
    Send$ = Send$ + Chr(13) + Chr(10)
    Sendlength = Len(send$)
    I2csend &B11011111 , Send(1) , Sendlength
Return
'---------------------------------------------------------------------------------
'--------- Subroutine for reading out the volume bargraph at edip 240-7 ----------
'---------------------------------------------------------------------------------
Readvol:
   Receivevol(1) = 27
   Receivevol(2) = 66
   Receivevol(3) = 83
   Receivevol(4) = 1
   I2csend &B11011111 , Receivevol(1) , 4
   I2creceive &B11011110 , Receivevol(1) , 0 , 5
   Volume = Receivevol(5)
Return